Imports istia.st.articles.dao

Namespace istia.st.articles.domain

	Public Class Achat

		' champs privs
		Private _article As article
		Private _qte As Integer

		' constructeur par dfaut
		Public Sub New()
		End Sub

		' constructeur avec paramtres
		Public Sub New(ByVal unArticle As article, ByVal qte As Integer)
			' on passe par les proprits
			Me.article = unArticle
			Me.qte = qte
		End Sub

		' proprits
		' article achet
		Public Property article() As article
			Get
				Return _article
			End Get
			Set(ByVal Value As article)
				_article = Value
			End Set
		End Property

		' qte achete
		Public Property qte() As Integer
			Get
				Return _qte
			End Get
			Set(ByVal Value As Integer)
				If Value < 0 Then
					Throw New Exception("Quantit [" + Value.ToString + "] invalide")
				End If
				_qte = Value
			End Set
		End Property

		' total achat
		Public ReadOnly Property totalAchat() As Double
			Get
				Return _qte * _article.prix
			End Get
		End Property

		' identit
		Public Overrides Function ToString() As String
			Return "[" + _article.ToString + "," + _qte.ToString + "]"
		End Function
	End Class

End Namespace
