Imports istia.st.articles.dao

Namespace istia.st.articles.domain
	Public Class AchatsArticles
		Implements IArticlesDomain

		'champs privs
		Private _articlesDao As IArticlesDao
		Private _erreurs As ArrayList

		' constructeur
		Public Sub New(ByVal articlesDao As IArticlesDao)
			_articlesDao = articlesDao
		End Sub

		' proprits
		Public ReadOnly Property erreurs() As ArrayList Implements IArticlesDomain.erreurs
			Get
				Return _erreurs
			End Get
		End Property

		' mthodes
		Public Function getAllArticles() As IList Implements IArticlesDomain.getAllArticles
			' liste de tous les articles
			Try
				Return _articlesDao.getAllArticles
			Catch ex As Exception
				_erreurs = New ArrayList
				_erreurs.Add("Erreur d'accs aux donnes : " + ex.Message)
			End Try
		End Function

		Public Function getArticleById(ByVal idArticle As Integer) As Article Implements IArticlesDomain.getArticleById
			' un article particulier
			Try
				Return _articlesDao.getArticleById(idArticle)
			Catch ex As Exception
				_erreurs = New ArrayList
				_erreurs.Add("Erreur d'accs aux donnes : " + ex.Message)
			End Try
		End Function

		Public Sub acheter(ByVal panier As Panier) Implements IArticlesDomain.acheter
			' achat d'un panier - les stocks des articles achets doivent tre dcrments
			_erreurs = New ArrayList
			Dim achat As achat
			Dim achats As ArrayList = panier.achats
			For i As Integer = achats.Count - 1 To 0 Step -1
				' dcrmenter stock article i
				achat = CType(achats(i), achat)
				Try
					If _articlesDao.changerStockArticle(achat.article.id, -achat.qte) = 0 Then
						' on n'a pas pu faire l'opration
						_erreurs.Add("L'achat " + achat.ToString + " n'a pu se faire - Vrifiez les stocks")
					Else
						' l'opration s'est faite - on enlve l'achat du panier
						panier.enlever(achat.article.id)
					End If
				Catch ex As Exception
					_erreurs = New ArrayList
					_erreurs.Add("Erreur d'accs aux donnes : " + ex.Message)
				End Try
			Next
		End Sub
	End Class

End Namespace
