Namespace istia.st.articles.domain

	Public Class Panier

		' champs privs
		Private _achats As New ArrayList
		Private _totalPanier As Double = 0

		' constructeur par dfaut
		Public Sub New()
		End Sub

		' proprits
		' liste des achats
		Public ReadOnly Property achats() As ArrayList
			Get
				Return _achats
			End Get
		End Property

		' total des achats
		Public ReadOnly Property totalPanier() As Double
			Get
				Return _totalPanier
			End Get
		End Property

		' mthodes
		Public Sub ajouter(ByVal unAchat As Achat)
			' on cherche si l'achat existe dj
			Dim iAchat As Integer = posAchat(unAchat.article.id)
			If iAchat <> -1 Then
				' on a trouv
				Dim achatCourant As Achat = CType(_achats(iAchat), Achat)
				achatCourant.qte += unAchat.qte
			Else
				' on n'a pas trouv
				_achats.Add(unAchat)
			End If
			' on incrmente le total du panier
			_totalPanier += unAchat.totalAchat
		End Sub

		' enlever un achat
		Public Sub enlever(ByVal idAchat As Integer)
			' on cherche l'achat
			Dim iachat As Integer = posAchat(idAchat)
			' si on a trouv, on enlve
			If iachat <> -1 Then
				Dim achatCourant As Achat = CType(_achats(iachat), Achat)
				' on enlve du panier
				_achats.RemoveAt(iachat)
				' on dcrmente le total du panier
				_totalPanier -= achatCourant.totalAchat
			End If
		End Sub

		Private Function posAchat(ByVal idArticle As Integer) As Integer
			' recherche un achat dans la liste des achats
			' rend sa position dans la liste ou -1 si pas trouv
			Dim achatCourant As Achat
			Dim trouv As Boolean = False
			Dim i As Integer = 0
			While Not trouv AndAlso i < _achats.Count
				' achat courant
				achatCourant = CType(_achats(i), Achat)
				' comparaison avec l'article cherch
				If achatCourant.article.id = idArticle Then
					Return i
				End If
				'achat suivant
				i += 1
			End While
			' pas trouv
			Return -1
		End Function

		' function identit
		Public Overrides Function ToString() As String
			Return _achats.ToString
		End Function
	End Class

End Namespace