Imports System
Imports System.Web
Imports System.Web.SessionState
Imports System.Configuration
Imports istia.st.articles.domain
Imports System.Collections
Imports Spring.Context

Namespace istia.st.articles.web

	Public Class GlobalWebArticles
		Inherits System.Web.HttpApplication

		' init application
		Sub Application_Start(ByVal sender As Object, ByVal e As EventArgs)

			' donnes locales
			Dim parameters() As String = {"urlMain", "urlErreurs", "urlInfos", "urlListe", "urlPanier", "urlPanierVide"}
			Dim erreurs As New ArrayList

			' on rcupre les paramtres d'initialisation de l'application
			Dim param As String
			For i As Integer = 0 To parameters.Length - 1
				' lecture dans fichier de conf
				param = ConfigurationSettings.AppSettings(parameters(i))
				If param Is Nothing Then
					' on note l'erreur
					erreurs.Add("Paramtre [" + parameters(i) + "] absent dans le fichier [web.config]")
				Else
					' on mmorise le paramtre dans l'application
					Application.Item(parameters(i)) = param
				End If
			Next
			' des erreurs ?
			If erreurs.Count = 0 Then
				Try
					' on cre un objet IArticlesDomain d'accs  la couche mtier
					Dim contexte As IApplicationContext = CType(ConfigurationSettings.GetConfig("spring/context"), IApplicationContext)
					Dim articlesDomain As IArticlesDomain = CType(contexte.GetObject("articlesDomain"), IArticlesDomain)
					' on mmorise l'objet dans l'application
					Application.Item("articlesDomain") = articlesDomain
				Catch ex As Exception
					' on mmorise l'erreur
					erreurs.Add("Erreur lors de la construction de l'objet d'accs  la couche mtier [" + ex.ToString + "]")
				End Try
			End If
			' les erreurs sont places dans l'application
			Application.Item("erreurs") = erreurs
			' c'est fini s'il y a eu des erreurs
			If erreurs.Count <> 0 Then Return
			' on construit un tableau d'options de menu
			Dim options As New Hashtable
			' on rcupre l'url du contrleur
			Dim urlMain As String = CType(Application.Item("urlMain"), String)
			Dim uneOption As Hashtable
			' liste des articles
			uneOption = New Hashtable
			uneOption.Add("href", urlMain + "?action=liste")
			uneOption.Add("lien", "Liste des articles")
			options.Add("liste", uneOption)
			' panier
			uneOption = New Hashtable
			uneOption.Add("href", urlMain + "?action=panier")
			uneOption.Add("lien", "Voir le panier")
			options.Add("panier", uneOption)
			' validation panier
			uneOption = New Hashtable
			uneOption.Add("href", urlMain + "?action=validationpanier")
			uneOption.Add("lien", "Valider le panier")
			options.Add("validationpanier", uneOption)
			' on met les options du menu dans l'application
			Application.Item("options") = options
			Return
		End Sub

		' init session
		Sub Session_Start(ByVal sender As Object, ByVal e As EventArgs)
			' on cre un panier pour le client
			Session.Item("panier") = New Panier
		End Sub
	End Class
End Namespace
