Imports System.Collections
Imports System
Imports System.Data

Imports Article = istia.st.articles.dao.Article
Imports istia.st.articles.domain

Namespace istia.st.articles.web

	' classe contrleur de l'application web
	Public Class MainWebArticles
		Inherits System.Web.UI.Page

		' champs privs
		Private articlesDomain As IArticlesDomain
		Private options As Hashtable

		' chargement de la page
		Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
			' on vrifie si l'application a dmarr correctement
			Dim erreurs As ArrayList = CType(Application.Item("erreurs"), ArrayList)
			' s'il y a des erreurs, on envoie la vue [erreurs]
			If erreurs.Count <> 0 Then
				context.Items("erreurs") = erreurs
				context.Items("options") = New Hashtable() {}
				Server.Transfer(CType(Application("urlErreurs"), String))
			End If
			' on rcupre l'objet d'accs  la classe mtier
			articlesDomain = CType(Application.Item("articlesDomain"), IArticlesDomain)
			' ainsi que les options de menu
			options = CType(Application.Item("options"), Hashtable)
			' on rcupre l'action  faire
			Dim action As String = Request.QueryString("action")
			If action Is Nothing Then
				action = "liste"
			End If
			' on excute l'action
			Select Case action
				Case "liste"
					doListe()
				Case "infos"
					doInfos()
				Case "achat"
					doAchat()
				Case "panier"
					doPanier()
				Case "retirerachat"
					doRetirerAchat()
				Case "validationpanier"
					doValidationPanier()
				Case Else
					doListe()
			End Select
		End Sub

		' mthodes de traitement des actions

		' liste des articles
		Public Sub doListe()
			' gestion des erreurs
			Dim erreurs As New ArrayList
			' on demande la liste des articles
			Dim articles As IList
			Try
				articles = articlesDomain.getAllArticles
			Catch ex As Exception
				' on note l'erreur
				erreurs.Add(ex.ToString)
			End Try
			' des erreurs ?
			If erreurs.Count <> 0 Then
				' affichage vue [erreurs]
				context.Items("erreurs") = erreurs
				context.Items("options") = New Hashtable() {CType(options("liste"), Hashtable)}
				Server.Transfer(CType(Application.Item("urlErreurs"), String))
			End If
			' affichage vue [liste]
			context.Items("articles") = articles
			context.Items("options") = New Hashtable() {CType(options("panier"), Hashtable)}
			If context.Items("message") Is Nothing Then context.Items("message") = ""
			Server.Transfer(CType(Application.Item("urlListe"), String))
		End Sub

		' infos sur un article
		Public Sub doInfos()
			' gestion des erreurs
			Dim erreurs As New ArrayList
			' on rcupre l'id de l'article demand
			Dim strId As String = Request.QueryString("id")
			' a-t-on qq chose ?
			If strId Is Nothing Then
				' pas normal - on envoie la page d'erreurs
				erreurs.Add("action incorrecte (action=infos, id=rien)")
				' si erreurs alors page d'erreurs
				context.Items("erreurs") = erreurs
				context.Items("options") = New Hashtable() {CType(options("liste"), Hashtable)}
				Server.Transfer(CType(Application.Item("urlErreurs"), String))
				Exit Sub
			End If
			' a-t-on un entier ?
			Dim id As Integer
			Try
				id = Integer.Parse(strId)
			Catch ex As Exception
				' pas normal - on envoie la page d'erreurs
				erreurs.Add("action incorrecte (action=infos, id[" + strId + "] invalide)")
				context.Items("erreurs") = erreurs
				context.Items("options") = New Hashtable() {CType(options("liste"), Hashtable)}
				Server.Transfer(CType(Application.Item("urlErreurs"), String))
				Exit Sub
			End Try
			' on demande l'article de cl id
			Dim unArticle As Article
			Try
				unArticle = articlesDomain.getArticleById(id)
			Catch ex As Exception
				' pb d'accs aux donnes
				erreurs.Add("Problme d'accs aux donnes (" + ex.ToString + ")")
				context.Items("erreurs") = erreurs
				context.Items("options") = New Hashtable() {CType(options("liste"), Hashtable)}
				Server.Transfer(CType(Application.Item("urlErreurs"), String))
				Exit Sub
			End Try
			' a-t-on rcupr un article ?
			If unArticle Is Nothing Then
				' l'article n'existe pas
				erreurs.Add("L'article d'id=" + id.ToString + " n'existe pas")
				context.Items("erreurs") = erreurs
				context.Items("options") = New Hashtable() {CType(options("liste"), Hashtable)}
				Server.Transfer(CType(Application.Item("urlErreurs"), String))
				Exit Sub
			End If
			' on a l'article - on le met dans la session courante
			Session.Item("article") = unArticle
			' on prpare son affichage
			context.Items("options") = New Hashtable() {CType(options("liste"), Hashtable)}
			context.Items("msg") = ""
			context.Items("qte") = ""
			Server.Transfer(CType(Application.Item("urlInfos"), String))
		End Sub

		' achat d'un article
		Public Sub doAchat()
			' achat d'un article
			' on rcupre l'article qui tait dans la session
			Dim unArticle As Article = CType(Session.Item("article"), Article)
			' a-t-on qq chose ?
			If unArticle Is Nothing Then
				' pas normal - on affiche la liste des articles
				doListe()
			End If
			' on rcupre la qt poste
			Dim strQte As String = Request.Form("txtQte")
			' a-t-on qq chose ?
			If strQte Is Nothing Then
				' pas normal - on envoie la liste des articles
				doListe()
			End If
			' a-t-on un entier ?
			Dim qte As Integer
			Try
				qte = Integer.Parse(strQte)
				If (qte <= 0) Then Throw New Exception
			Catch ex As Exception
				' pas normal - on envoie la page d'infos avec le msg d'erreur
				context.Items("options") = New Hashtable() {CType(options("liste"), Hashtable)}
				context.Items("msg") = "Quantit incorrecte"
				context.Items("qte") = strQte
				Server.Transfer(CType(Application.Item("urlInfos"), String))
			End Try
			' tout va bien - on met l'achat dans le panier du client
			Dim unPanier As Panier = CType(Session.Item("panier"), Panier)
			unPanier.ajouter(New Achat(unArticle, qte))
			' on affiche la liste des articles
			doListe()
		End Sub

		' suppression d'un achat
		Public Sub doRetirerAchat()
			'on rcupre le panier dans la session
			Dim unPanier As Panier = CType(Session.Item("panier"), Panier)
			' on enlve l'achat
			Try
				' on rcupre l'id de l'article retir
				Dim idArticle As Integer = Integer.Parse(Request.QueryString("id"))
				' on l'enlve du panier
				unPanier.enlever(idArticle)
			Catch ex As Exception
				' on affiche la liste des articles
				doListe()
			End Try
			' on affiche le panier
			doPanier()
		End Sub

		' visualisation panier
		Public Sub doPanier()
			'on rcupre le panier dans la session
			Dim unPanier As Panier = CType(Session.Item("panier"), Panier)
			' panier vide ?
			If unPanier.achats.Count = 0 Then
				' affichage panier vide
				context.Items("options") = New Hashtable() {CType(options("liste"), Hashtable)}
				Server.Transfer(CType(Application.Item("urlPanierVide"), String))
			End If
			' affichage panier non vide
			context.Items("options") = New Hashtable() {CType(options("liste"), Hashtable), CType(options("validationpanier"), Hashtable)}
			Server.Transfer(CType(Application.Item("urlPanier"), String))
		End Sub

		' achat panier
		Public Sub doValidationPanier()
			' au dpart, pas d'erreurs
			Dim erreurs As ArrayList
			'on rcupre le panier dans la session
			Dim unPanier As Panier = CType(Session.Item("panier"), Panier)
			' on tente de valider le panier
			Try
				articlesDomain.acheter(unPanier)
				' on note les ventuelles erreurs d'achats
				erreurs = articlesDomain.erreurs
			Catch ex As Exception
				' on note l'erreur
				erreurs = New ArrayList
				erreurs.Add(String.Format("Erreur lors de la validation du panier [{0}]", ex.Message))
			End Try
			' si erreurs alors page d'erreurs
			If erreurs.Count <> 0 Then
				context.Items("erreurs") = erreurs
				context.Items("options") = New Hashtable() {CType(options("liste"), Hashtable), CType(options("panier"), Hashtable)}
				Server.Transfer(CType(Application.Item("urlErreurs"), String))
				Exit Sub
			End If
			' tout va bien - on affiche la liste des articles avec un message de russite
			context.Items("message") = "Votre panier a t valid"
			doListe()
		End Sub

	End Class

End Namespace
