Imports System
Imports System.Collections
Imports System.Data
Imports istia.st.articles.dao
Imports istia.st.articles.domain

Namespace istia.st.articles.web
	' gre la page d'affichage du panier
	Public Class PanierWebarticles
		Inherits System.Web.UI.Page
		Protected WithEvents DataGridAchats As System.Web.UI.WebControls.DataGrid
		Protected WithEvents lblTotal As System.Web.UI.WebControls.Label
		Protected WithEvents entete As New EnteteWebArticles

		Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
			' on lie les options de menu  rptmenu
			entete.actions = CType(context.Items("options"), Hashtable())
			' on rcupre le panier
			Dim unPanier As Panier = CType(Session.Item("panier"), Panier)
			' on transfre les achats dans un tableau de lignes d'achats
			Dim achats(unPanier.achats.Count - 1) As LigneAchat
			' on change le type des lments du ArrayList
			For i As Integer = 0 To achats.Length - 1
				achats(i) = New LigneAchat(CType(unPanier.achats(i), Achat))
			Next
			' on lie les donnes aux composants [DataGrid] de la page
			With DataGridAchats
				.DataSource = achats
				.DataBind()
			End With
			' on affiche le total  payer
			lblTotal.Text = unPanier.totalPanier.ToString
		End Sub

		' ligne d'achat construite  partir d'un objet Achat
		Private Class LigneAchat
			Inherits Achat

			' constructeur reoit un achat
			Public Sub New(ByVal unAchat As Achat)
				Me.article = unAchat.article
				Me.qte = unAchat.qte
			End Sub

			' id : rend l'id de l'article achet
			Public ReadOnly Property id() As Integer
				Get
					Return article.id
				End Get
			End Property

			' nom : nom de l'article achet
			Public ReadOnly Property nom() As String
				Get
					Return article.nom
				End Get
			End Property

			' prix de l'article achet
			Public ReadOnly Property prix() As Double
				Get
					Return article.prix
				End Get
			End Property

		End Class

		Private Sub InitializeComponent()

		End Sub
	End Class
End Namespace
