Imports System
Imports System.Collections
Imports System.Data.Odbc

Namespace istia.st.articles.dao

	Public Class ArticlesDaoPlainODBC
		Implements istia.st.articles.dao.IArticlesDao

		' champs privs
		Private connexion As OdbcConnection = Nothing
		Private DSN As String

		Public Sub New(ByVal DSN As String, ByVal uid As String, ByVal password As String)
			'on rcupre le nom de la base pass en argument
			Me.DSN = DSN
			Dim connectString As String = String.Format("DSN={0};UID={1};PASSWORD={2}", DSN, uid, password)
			'on instancie la connexion
			connexion = New OdbcConnection(connectString)
		End Sub

		Public Function ajouteArticle(ByVal unArticle As Article) As Integer Implements IArticlesDao.ajouteArticle
			Try
				'on excute la requte d'insertion
				Return executeUpdate(String.Format("insert into articles(id,nom,prix,stockactuel,stockminimum) values ({0},'{1}',{2},{3},{4})", unArticle.id, unArticle.nom, unArticle.prix, unArticle.stockactuel, unArticle.stockminimum))
			Catch ex As Exception
				'erreur de requte
				Throw New Exception(String.Format("Erreur  l'ajout de l'article [{0}] : {1}", unArticle.ToString, ex.Message))
			End Try
		End Function

		Public Function changerStockArticle(ByVal idArticle As Integer, ByVal mouvement As Integer) As Integer Implements IArticlesDao.changerStockArticle
			Try
				'on excute la requte de changement
				Return executeUpdate(String.Format("update articles set stockactuel=stockactuel + {0} where id={1} and (stockactuel + {0}) >=0", mouvement, idArticle))
			Catch ex As Exception
				'erreur de requte
				Throw New Exception(String.Format("Erreur lors du changement de stock [idArticle={0}, mouvement={1}] : [{2}]", idArticle, mouvement, ex.Message))
			End Try
		End Function

		Public Sub clearAllArticles() Implements IArticlesDao.clearAllArticles
			Try
				'on excute la requte d'insertion
				executeUpdate("delete from articles")
			Catch ex As Exception
				'erreur de requte
				Throw New Exception(String.Format("Erreur lors de la suppression des articles : {0}", ex.Message))
			End Try
		End Sub

		Public Function getAllArticles() As System.Collections.IList Implements IArticlesDao.getAllArticles
			Try
				'on excute la requte
				Dim articles As IList = executeQuery("select id,nom,prix,stockactuel,stockminimum from articles")
				'on retourne le liste
				Return articles
			Catch ex As Exception
				'erreur de requte
				Throw New Exception(String.Format("Erreur lors de l'obtention des articles [select id,nom,prix,stockactuel,stockminimum from articles]: {0}", ex.Message))
			End Try
		End Function

		Public Function getArticleById(ByVal idArticle As Integer) As Article Implements IArticlesDao.getArticleById
			Try
				'on excute la requte
				Dim articles As IList = executeQuery(String.Format("select id,nom,prix,stockactuel,stockminimum from articles where id={0}", idArticle))
				'on test si l'on a trouv l'article
				If articles.Count = 0 Then Return Nothing
				'on retourne l'article
				Return CType(articles.Item(0), Article)
			Catch ex As Exception
				'erreur de requte
				Throw New Exception(String.Format("Erreur lors de la recherche de l'article [{0} : {1}", idArticle, ex.Message))
			End Try
		End Function

		Public Function modifieArticle(ByVal unArticle As Article) As Integer Implements IArticlesDao.modifieArticle
			Try
				'on excute la requte d'insertion
				Return executeUpdate(String.Format("update articles set nom='{0}', prix={1}, stockactuel={2}, stockminimum={3} where id={4}", unArticle.nom, unArticle.prix, unArticle.stockactuel, unArticle.stockminimum, unArticle.id))
			Catch ex As Exception
				'erreur de requte
				Throw New Exception("Erreur lors de la modification de l'article [" + unArticle.ToString + "]", ex)
			End Try
		End Function

		Public Function supprimeArticle(ByVal idArticle As Integer) As Integer Implements IArticlesDao.supprimeArticle
			Try
				'on excute la requte de suppression
				Return executeUpdate(String.Format("delete from articles where id={0}", idArticle))
			Catch ex As Exception
				'erreur de requte
				Throw New Exception(String.Format("Erreur lors de la suppression de l'article [id={0}] : {1}", idArticle, ex.Message))
			End Try
		End Function

		Private Function executeQuery(ByVal query As String) As IList
			'section critique
			SyncLock Me
				Try
					'dclaration de l'objet permettant l'accs  toutes les lignes de la table rsultat
					Dim myReader As OdbcDataReader = Nothing
					'on cre une connexion  la BDD
					connexion.Open()
					'on cre l'objet commande
					Dim myOdbcCommand As New OdbcCommand(query)
					myOdbcCommand.Connection = connexion
					'on excute la requte
					myReader = myOdbcCommand.ExecuteReader()
					'on dclare un tableau pour le retourner par la suite
					Dim articles As IList = New ArrayList
					While myReader.Read()
						'on prpare un article avec les valeurs du reader
						Dim unArticle As Article = New Article
						unArticle.id = CType(myReader.Item("id"), Integer)
						unArticle.nom = CType(myReader.Item("nom"), String)
						unArticle.prix = CType(myReader.Item("prix"), Double)
						unArticle.stockactuel = CType(myReader.Item("stockactuel"), Integer)
						unArticle.stockminimum = CType(myReader.Item("stockminimum"), Integer)
						'on ajoute l'article  la list
						articles.Add(unArticle)
					End While
					'on ferme l'objet de lecture
					myReader.Close()
					'on ferme la connexion
					connexion.Close()
					'on retourne le rsultat
					Return articles
				Finally
					If IsNothing(connexion) = False Then connexion.Close()
				End Try
				'fin de section critique
			End SyncLock
		End Function

		Private Function executeUpdate(ByVal update As String) As Integer
			'section critique
			SyncLock Me
				Try
					'on cre une connexion  la BDD
					connexion.Open()
					'on cre l'objet commande
					Dim myOdbcCommand As New OdbcCommand(update)
					myOdbcCommand.Connection = connexion
					'on excute la requte
					Dim nbLignes As Integer = myOdbcCommand.ExecuteNonQuery()
					'on ferme la connexion
					connexion.Close()
					'on retourne le rsultat
					Return nbLignes
				Finally
					If IsNothing(connexion) = False Then connexion.Close()
				End Try
				'fin de section critique
			End SyncLock
		End Function
	End Class

End Namespace
