Imports System

Namespace istia.st.articles.dao

	Public Class Article

		' champs privs
		Private _id As Integer
		Private _nom As String
		Private _prix As Double
		Private _stockactuel As Integer
		Private _stockminimum As Integer

		' id article
		Public Property id() As Integer
			Get
				Return _id
			End Get
			Set(ByVal Value As Integer)
				If Value <= 0 Then
					Throw New Exception("Le champ id [" + Value.ToString + "] est invalide")
				End If
				Me._id = Value
			End Set
		End Property

		' nom article
		Public Property nom() As String
			Get
				Return _nom
			End Get
			Set(ByVal Value As String)
				If Value Is Nothing OrElse Value.Trim.Equals("") Then
					Throw New Exception("Le champ nom [" + Value + "] est invalide")
				End If
				Me._nom = Value
			End Set
		End Property

		' prix article
		Public Property prix() As Double
			Get
				Return _prix
			End Get
			Set(ByVal Value As Double)
				If Value < 0 Then
					Throw New Exception("Le champ prix [" + Value.ToString + "] est invalide")
				End If
				Me._prix = Value
			End Set
		End Property

		' stock actuel article
		Public Property stockactuel() As Integer
			Get
				Return _stockactuel
			End Get
			Set(ByVal Value As Integer)
				If Value < 0 Then
					Throw New Exception("Le champ stockActuel [" + Value.ToString + "] est invalide")
				End If
				Me._stockactuel = Value
			End Set
		End Property

		' stock minimum article
		Public Property stockminimum() As Integer
			Get
				Return _stockminimum
			End Get
			Set(ByVal Value As Integer)
				If Value < 0 Then
					Throw New Exception("Le champ stockMinimum [" + Value.ToString + "] est invalide")
				End If
				Me._stockminimum = Value
			End Set
		End Property

		' constructeur par dfaut
		Public Sub New()
		End Sub

		' constructeur avec proprits
		Public Sub New(ByVal id As Integer, ByVal nom As String, ByVal prix As Double, ByVal stockactuel As Integer, ByVal stockminimum As Integer)
			Me.id = id
			Me.nom = nom
			Me.prix = prix
			Me.stockactuel = stockactuel
			Me.stockminimum = stockminimum
		End Sub

		' mthode d'identification de l'article
		Public Overrides Function ToString() As String
			Return "[" + id.ToString + "," + nom + "," + prix.ToString + "," + stockactuel.ToString + "," + stockminimum.ToString + "]"
		End Function
	End Class
End Namespace
